class Heroes.Bone extends Heroes.WorldObject
{
   var xr;
   var zr;
   var origX;
   var x;
   var origZ;
   var z;
   var appearAt;
   var speed;
   var radius;
   var isDead = false;
   var angle = 0;
   var isOnRadar = false;
   function Bone()
   {
      super();
      if(this.xr == -1)
      {
         this.xr = this._width / 2;
      }
      if(this.zr == -1)
      {
         this.zr = this._width / 2;
      }
      this.origX = this.x;
      this.origZ = this.z;
      this.updateBonePosition(false);
   }
   function onEnterFrame()
   {
      if(!this.isOnRadar && this.appearAt <= this._parent.player.currentMission)
      {
         this.updateBonePosition(true);
      }
      if(super.isOnScreen() && this.appearAt <= this._parent.player.currentMission)
      {
         this._visible = true;
         this.updateBonePosition(true);
         var _loc4_ = this.x - this._parent.player.x;
         var _loc3_ = this.z - this._parent.player.z;
         var _loc6_ = Math.sqrt(Math.pow(_loc4_,2) + Math.pow(_loc3_,2));
         var _loc7_ = Math.atan2(_loc3_,_loc4_);
         if(this._parent.player.x > this.x - this.xr && this._parent.player.x < this.x + this.xr)
         {
            if(this._parent.player.z > this.z)
            {
               var _loc5_ = this.zr * Math.cos(Math.asin((this._parent.player.x - this.x) / this.xr));
               if(_loc5_ > this._parent.player.z - this.z)
               {
                  this.die();
               }
            }
            else
            {
               _loc5_ = (- this.zr) * Math.cos(Math.asin((this._parent.player.x - this.x) / this.xr));
               if(_loc5_ < this._parent.player.z - this.z)
               {
                  this.die();
               }
            }
         }
         super.onEnterFrame();
      }
      else
      {
         this._visible = false;
      }
   }
   function updateBonePosition(updateRadar)
   {
      this.angle += this.speed;
      this.x = this.origX + this.radius * Math.sin(this.angle);
      this.z = this.origZ + this.radius * Math.cos(this.angle);
      if(updateRadar)
      {
         if(!this.isOnRadar)
         {
            this.isOnRadar = true;
            this._parent._parent.radar.addItem("treat",this._name);
         }
         this._parent._parent.radar.updateItem(this._name);
      }
   }
   function die()
   {
      if(!this.isDead)
      {
         this.isDead = true;
         this._parent.player.onCollectBone();
         this._parent._parent.radar.removeItem(this._name);
         this.playSound("dogmunch");
         §§push(this.gotoAndPlay("die"));
      }
   }
   function onDead()
   {
      this.removeMovieClip();
   }
}
