class Heroes.Distraction extends Heroes.HeavyEllipticalCylinder
{
   var x;
   var z;
   var distractionRadius;
   var distractionWeight;
   var distractionCost;
   var distractSounds;
   var lastDistractSoundTime;
   var lastDistractSoundNumber;
   var isOnRadar = false;
   function Distraction()
   {
      super();
   }
   function onEnterFrame()
   {
      if(!this.isOnRadar)
      {
         this.isOnRadar = true;
         trace("distraction not on radar");
         this._parent._parent.radar.addItem("baddie",this._name);
         this._parent._parent.radar.updateItem(this._name);
      }
      if(super.isOnScreen())
      {
         this._parent._parent.radar.setItemState(this._name,"moving");
         var _loc5_ = this.x - this._parent.player.x;
         var _loc3_ = this.z - this._parent.player.z;
         var _loc6_ = Math.sqrt(Math.pow(_loc5_,2) + Math.pow(_loc3_,2));
         if(this._parent.player.doRespondToUser && !this._parent.player.isWaitingToMove && _loc6_ < this.distractionRadius)
         {
            var _loc4_ = Math.atan2(_loc3_,_loc5_) - 1.5707963267948966;
            this._parent.player.x -= this.distractionWeight * Math.sin(_loc4_) * ((100 - this._parent.player.intelligence) / 100);
            this._parent.player.z += this.distractionWeight * Math.cos(_loc4_) * ((100 - this._parent.player.intelligence) / 100);
            this.distractPlayer();
         }
         this._parent._parent.radar.updateItem(this._name);
         super.onEnterFrame();
      }
      else
      {
         this._parent._parent.radar.setItemState(this._name,"stopped");
         this._visible = false;
      }
   }
   function distractPlayer()
   {
      if(!this._parent.player.isWaitingToMove)
      {
         this.playDistractSound();
         this._parent.player.distract(this.distractionCost * 1.6);
      }
   }
   function playDistractSound()
   {
      if(this.distractSounds != null && this.distractSounds.length > 0)
      {
         var _loc2_ = [6.5,4,3];
         var _loc4_ = _loc2_[Math.min(this.distractSounds.length - 1,_loc2_.length - 1)] * 1000;
         if(this.lastDistractSoundTime == null)
         {
            this.lastDistractSoundTime = - _loc4_;
         }
         var _loc3_ = getTimer() - this.lastDistractSoundTime;
         if(_loc3_ > this.lastDistractSoundTime)
         {
            this.lastDistractSoundTime = getTimer();
            if(this.lastDistractSoundNumber == null)
            {
               this.lastDistractSoundNumber = 0;
            }
            else
            {
               this.lastDistractSoundNumber = this.lastDistractSoundNumber + 1;
            }
            if(this.lastDistractSoundNumber >= this.distractSounds.length)
            {
               this.lastDistractSoundNumber = 0;
            }
            this.playSound(this.distractSounds[this.lastDistractSoundNumber]);
         }
      }
   }
}
