class Heroes.World extends MovieClip
{
   var slots;
   var baddyBoxes;
   var backdrop;
   var allFallNowTimer;
   var player;
   var killCount = 0;
   var doFallNow = false;
   var readyForGangSound = true;
   var backTileWidth = 470;
   function World()
   {
      super();
      this.slots = new Array();
      this.baddyBoxes = new pi.Hashtable();
   }
   function onEnterFrame()
   {
      this.backdrop.gotoAndStop(1 - int(this._x / this.backTileWidth));
   }
   function restart()
   {
      this._parent.timer.stop();
      this._parent.outOfTime.gotoAndStop("hide");
      this._parent.outOfBrain.gotoAndStop("hide");
      this._parent.gotoAndPlay(this._parent._currentFrame - 1);
   }
   function updateDepth(myObject, z)
   {
      var _loc2_ = z;
      while(_loc2_ > 0)
      {
         if(this.slots[_loc2_] == myObject._name)
         {
            break;
         }
         if(this.slots[_loc2_] == null)
         {
            this.setDepth(myObject,myObject.getDepth(),_loc2_);
            break;
         }
         _loc2_ = _loc2_ - 1;
      }
   }
   function setDepth(myObject, oldDepth, newDepth)
   {
      myObject.swapDepths(newDepth);
      if(oldDepth >= 0)
      {
         this.slots[oldDepth] = null;
      }
      this.slots[newDepth] = myObject._name;
   }
   function addBox(newBox, name)
   {
      this.baddyBoxes.addItem(name,newBox);
      if(this.readyForGangSound && this.baddyBoxes.keys.length == 2)
      {
         this.readyForGangSound = false;
         pi.AudioLibrary.playSound("baddieEntry",1);
      }
   }
   function removeBox(boxName)
   {
      if(this.baddyBoxes.containsKey(boxName))
      {
         this.baddyBoxes.removeItem(boxName);
         this.killCount = this.killCount + 1;
         if(this.baddyBoxes.keys.length == 0)
         {
            this.killCount = 0;
            this._parent.goArrow.show();
         }
         trace("KILL COUNT **************     " + this.killCount);
      }
      if(this.baddyBoxes.keys.length == 0)
      {
         this.readyForGangSound = true;
      }
   }
   function setBoxLocation(boxName, x, y, z)
   {
      this.baddyBoxes.getItem(boxName).x = x;
      this.baddyBoxes.getItem(boxName).y = y;
      this.baddyBoxes.getItem(boxName).z = z;
   }
   function setBoxSize(boxName, w, h, b)
   {
      this.baddyBoxes.getItem(boxName).w = w;
      this.baddyBoxes.getItem(boxName).h = h;
      this.baddyBoxes.getItem(boxName).b = b;
   }
   function isHitting(box1, box2Name)
   {
      return this.baddyBoxes.getItem(box2Name).isHitting(box1);
   }
   function isHittingWhich(box1)
   {
      var _loc2_ = undefined;
      for(_loc2_ in this.baddyBoxes.keys)
      {
         if(box1.isHitting(this.baddyBoxes.vals[_loc2_]))
         {
            return this.baddyBoxes.keys[_loc2_];
         }
      }
      return null;
   }
   function getNearestBaddyDistance(baddyName)
   {
      var _loc7_ = 1.7976931348623157e+308;
      var _loc3_ = undefined;
      for(_loc3_ in this.baddyBoxes.keys)
      {
         if(this.baddyBoxes.keys[_loc3_] != baddyName)
         {
            var _loc6_ = Math.pow(this[this.baddyBoxes.keys[_loc3_]].x - this[baddyName].x,2);
            var _loc5_ = Math.pow(this[this.baddyBoxes.keys[_loc3_]].z - this[baddyName].z,2);
            var _loc2_ = Math.sqrt(_loc6_ + _loc5_);
            if(_loc2_ < _loc7_)
            {
               _loc7_ = _loc2_;
            }
         }
      }
      return _loc2_;
   }
   function contains(baddyName)
   {
      return this.baddyBoxes.containsKey(baddyName);
   }
   function allFall(fallTime)
   {
      this.allFallNowTimer = getTimer() + fallTime;
      this.doFallNow = true;
   }
   function allFallNow()
   {
      var _loc3_ = 0;
      while(_loc3_ < this.baddyBoxes.keys.length)
      {
         var _loc2_ = this.baddyBoxes.keys[_loc3_];
         if(this.player.x < this[_loc2_].x)
         {
            this[_loc2_].onHit("allFall",0,true,50,0,0);
         }
         else
         {
            this[_loc2_].onHit("allFall",0,true,-50,0,0);
         }
         _loc3_ = _loc3_ + 1;
      }
   }
   function allThrust(x, thrust, pinch)
   {
      var _loc4_ = 0;
      while(_loc4_ < this.baddyBoxes.keys.length)
      {
         var _loc2_ = this.baddyBoxes.keys[_loc4_];
         var _loc5_ = Math.abs(this[_loc2_].x - x);
         var _loc3_ = thrust / (thrust / pinch * _loc5_ + 1);
         this[_loc2_].dy = _loc3_ / 2;
         if(this.player.x < this[_loc2_].x)
         {
            this[_loc2_].onHit("allThrust",Math.round(Math.abs(_loc3_ / 15)),true,_loc3_,0,0);
         }
         else
         {
            this[_loc2_].onHit("allThrust",Math.round(Math.abs(_loc3_ / 15)),true,- _loc3_,0,0);
         }
         _loc4_ = _loc4_ + 1;
      }
   }
   function hideBaddies()
   {
      var _loc2_ = 0;
      while(_loc2_ < this.baddyBoxes.keys.length)
      {
         var _loc3_ = this.baddyBoxes.keys[_loc2_];
         this[_loc3_]._visible = false;
         _loc2_ = _loc2_ + 1;
      }
   }
   function traceBaddyStatus()
   {
      trace("");
      trace("************ baddy status ***********");
      var _loc3_ = 0;
      while(_loc3_ < this.baddyBoxes.keys.length)
      {
         var _loc2_ = this.baddyBoxes.keys[_loc3_];
         trace(this[_loc2_]._name + ": _currentframe=" + this[_loc2_]._currentframe + " state=" + this[_loc2_].state + " deathCounter=" + this[_loc2_].deathCounter);
         _loc3_ = _loc3_ + 1;
      }
   }
}
